summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: e0e3ba2)
raw | patch | inline | side by side (parent: e0e3ba2)
author | Lukas Sandström <lukass@etek.chalmers.se> | |
Wed, 14 Dec 2005 23:36:35 +0000 (00:36 +0100) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Thu, 15 Dec 2005 01:02:03 +0000 (17:02 -0800) |
Fix bugs in git-rebase wrt rebasing another branch than
the current HEAD, rebasing with a dirty working dir,
and rebasing a proper decendant of the target branch.
[jc: with a bit of hand-merging]
Signed-off-by: Lukas Sandström <lukass@etek.chalmers.se>
Signed-off-by: Junio C Hamano <junkio@cox.net>
the current HEAD, rebasing with a dirty working dir,
and rebasing a proper decendant of the target branch.
[jc: with a bit of hand-merging]
Signed-off-by: Lukas Sandström <lukass@etek.chalmers.se>
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-rebase.sh | patch | blob | history |
diff --git a/git-rebase.sh b/git-rebase.sh
index c1619ff1400f68300d5026a00baf72e27f268ba1..16d4359830d7f987f571f8d3520f60062f60fab6 100755 (executable)
--- a/git-rebase.sh
+++ b/git-rebase.sh
exit 1
fi
-# The other head is given. Make sure it is valid.
-other=$(git-rev-parse --verify "$1^0") || usage
-
-# Make sure we have HEAD that is valid.
-head=$(git-rev-parse --verify "HEAD^0") || exit
-
# The tree must be really really clean.
git-update-index --refresh || exit
diff=$(git-diff-index --cached --name-status -r HEAD)
-case "$different" in
+case "$diff" in
?*) echo "$diff"
exit 1
;;
esac
+# The other head is given. Make sure it is valid.
+other=$(git-rev-parse --verify "$1^0") || usage
+
+# Make sure the branch to rebase is valid.
+head=$(git-rev-parse --verify "${2-HEAD}^0") || exit
+
# If the branch to rebase is given, first switch to it.
case "$#" in
2)
- head=$(git-rev-parse --verify "$2^") || usage
git-checkout "$2" || usage
esac
-# If the HEAD is a proper descendant of $other, we do not even need
-# to rebase. Make sure we do not do needless rebase. In such a
-# case, merge-base should be the same as "$other".
mb=$(git-merge-base "$other" "$head")
+
+# Check if we are already based on $other.
if test "$mb" = "$other"
then
echo >&2 "Current branch `git-symbolic-ref HEAD` is up to date."
# Rewind the head to "$other"
git-reset --hard "$other"
+
+# If the $other is a proper descendant of the tip of the branch, then
+# we just fast forwarded.
+if test "$mb" = "$head"
+then
+ echo >&2 "Fast-forwarded $head to $other."
+ exit 0
+fi
+
git-format-patch -k --stdout --full-index "$other" ORIG_HEAD |
git am --binary -3 -k